Imports Microsoft.VisualBasic
Imports System.IO.IsolatedStorage
Imports System.Collections.Generic
Imports System


Namespace Samples
	Public Class CacheIndex
		Private Const XAPCACHENAME As String = "XapCache"
		Private m_ItemsIndex As Dictionary(Of String, Object)

		Public Sub New()
			Dim iss As IsolatedStorageSettings = IsolatedStorageSettings.ApplicationSettings
			If iss.Contains(XAPCACHENAME) Then
				m_ItemsIndex = TryCast(iss(XAPCACHENAME), Dictionary(Of String, Object))
			Else
				m_ItemsIndex = New Dictionary(Of String, Object)()
				iss(XAPCACHENAME) = m_ItemsIndex
				iss.Save()
			End If
		End Sub

		Public Function IsExpired(ByVal xapFile As String) As Boolean
			Dim expired As Boolean = True
			If m_ItemsIndex.ContainsKey(xapFile) Then
				Dim dt As DateTime = CDate(m_ItemsIndex(xapFile))

				expired = dt.AddSeconds(60) < DateTime.Now ' Keep it for 1 minute
				If expired Then
					Remove(xapFile)
				End If
			End If

			Return expired
		End Function

		Public Sub Add(ByVal xapFile As String)
			m_ItemsIndex(xapFile) = DateTime.Now
			Dim iss As IsolatedStorageSettings = IsolatedStorageSettings.ApplicationSettings
			iss.Save()
		End Sub

		Public Sub Remove(ByVal xapFile As String)
			m_ItemsIndex.Remove(xapFile)
			Dim iss As IsolatedStorageSettings = IsolatedStorageSettings.ApplicationSettings
			iss.Save()
		End Sub

	End Class
End Namespace
